 '  programme QuickBasic
 '  Rsolution  sur le Rubik's Cube par Alain Renier anne 2011.
	' AVERTISSEMENT: Les accents peuvent manquer du fait
	'   de la diffrence d'encodage entre les codes ANSI, UTF8, 1252 de windows
	'   et internationaux 850 et 863 (Franais canadien) de MS-DOS.
	' - Fonctionne sous Windows XP. 
	' - Configurer CMD.EXE en mode plein-cran, taille caractres 8 x 8.
	' - Ligne de commande de QuickBasic:  QB /H /L /AH
	' ATTENTION !   Si QBASIC est implant sur un disque diffrent de "E:\"
	' - Modifier la ligne "Monv$ dans CUBRN2M.BI
	' - Le programme ncessite un sous-dossier de Quickbasic (directory) nomm RUBIK.
	' - dans ce dossier doivent tre implants les fichiers
	' - CUBDATA.RBK	 et	TRANSIND.RBK
	' - CUBRN2M.BI		 et	CUBRN2M.BAS
	'    Ainsi que les fichiers "RBIK1.RBK "RUBIKX.RBK"  (X= numro d'ordre)
	'   s'ils existent.
	' - Si les fichiers ne sont pas dans cette directory, le programme ne marchera pas
	'   {arrt avec message !.}
	' - D'autre part, on peut sauvegarder jusqu' 16 fichiers, de donnes des facettes
	' - entres une  une. 
	' - Les fichiers de sauvegarde sont nomms "RUBIK1.RBK   RUBIK16.RBK"
	' - Quelques dtails sur les tableaux, de variables, utiliss:
	' - CF%(i%,j%)	Tableau miroir contient la couleur de la facette
	' - TF%(k%)		numro du cube devant occuper la position k
	' - Configuration courante
	' - C%(i%,j%) 	Couleur de la facette i%,j%; et poids du cube lmentaire
	' - T%(K%)	 	numro du cube occupant la position k
	' - Z%(K%)		position occupe par le cube k
	' - CO%(6)		Contient la couleur affecte par dfaut
	' - VO%(6)		Suite du Poids binaire des valeurs 1, 2, 4, 8, 16 ou 32.
	' - Couleurs du cube par dfaut
	' - Blanc	=	1,	Vert		=	2,	Rouge	=	3,
	' - Bleu	=	4,	Orange	=	5,	jaune	=	6 
	' - P%  tableau de 9 positions, mais 6 seulement utilises pour le cube
	' - Couleurs relles
	' - P%(1 )  (6) 	Contient la couleur relle pour l'cran (SCREEN 12 MS-DOS) dans l'ordre :
	' - Blanc	=	15,	Vert		=	2,	Rouge	=	4,
	' - Bleu	=	9,	Orange	=	12,	Jaune	=	14
	' - P%(7)  (9) pour utilisation dans le programme
	' - Cyan	=	11,	Gris		=	8, Verlight		=	10
	' - SS%(20) 	somme des poids 2^x-1  des sommets et des artes
	' - Initialisation
	' - tableaux des rpertoires des mouvements (contenus dans CUBDATA.RBK)
	' 	Bf1$(112)	-->	donnes	"Rf1$" : 	affichage
	' 	Bc1$(112)	-->	donnes	"Cm1$" : 	excution
	' 	Bf2$(99)	-->	donnes	"Rf2$" :	affichage
	' 	Bc2$(99) 	-->	donnes	"Cm2$" :	excution
	' 	Bf3$(27) 	-->	donnes	"Rf3$" :	affichage
	' 	Bc3$(27)	-->	donnes	"Cm3$" :	excution
	' - tableaux d'index:   (contenus dans TRASIND.RBK)
	'	Id1% integer	-->	pointe sur les donnes de Bf1$ et Bc1$
	'	Id2% integer	-->	pointe sur les donnes de Bf2$ et Bc2$
	'	Id3% integer	-->	pointe sur les donnes de Bf3$ et Bc3$
	'	so%(54) integer-->	utilis pour calcul du coefficient K% dans calcv
	'************************************************************************************************  
5	' $INCLUDE: 'cubrn2M.bi'
	' $DYNAMIC 
	CLS
	CHDIR (Monv$)
	' delta temps = 0
	drl# = 0
	' coefficient sinus x ( en degr)
	Kfsn% = (CINT(angl * (SIN(angl * (pi# / 180)))))  '  sin30 = 1/2 donc Kfsn% = 15
	' Dans le cas possible d'une erreur
	ON ERROR GOTO traiterreur
	Infic1$ = "cubdata.rbk"
	Infich% = FREEFILE
	OPEN Infic1$ FOR INPUT AS #Infich%
	'initialiser les tableaux  de donnes Bf1$ et Bc1$
	Tablo 224, Infich%, Bf1$(), Bc1$()
	'initialiser les tableaux  de donnes Bf2$ et Bc2$
	Tablo 198, Infich%, Bf2$(), Bc2$()
	'initialiser les tableaux  de donnes Bf3$ et Bc3$
	Tablo 54, Infich%, Bf3$(), Bc3$()
	CLOSE #Infich%
	Infich$ = "transind.rbk"
	Infich% = FREEFILE
	OPEN Infich$ FOR BINARY AS #Infich%
	'initialiser les tableaux d'index
	Tablau 36, Infich%, Id1%(), Id2%()
	Tablax 6, Infich%, Id3%()
	'initialiser le tableau de sauts
	Tablax 54, Infich%, so%()
	'initialiser les tableaux d'appels Test, TestT1
	Tablat 78, Infich%, Aptst(), Aptsk(), 1
	'initialiser les tableaux d'appels TestK1, TestK2
	Tablat 35, Infich%, Aptst(), Aptsk(), 2
	' initialiser tableau des ensembles sommets (8) et artes(12)
	Tablax 20, Infich%, SS%()
	CLOSE #Infich%
	FOR i% = 1 TO nbfac%
		' couleur virtuelle des faces
		CO%(i%) = i%
		' valeur (poids des facettes) VO%(x) = 1, 2, 4, 8, 16 ou 32
		VO%(i%) = 2 ^ (i% - 1)
		' W%(x) contient la couleur point par la valeur du poids de la facette.
		W%(VO%(i%)) = i%
	NEXT i%
	' Au dpart, le tableau, des fichiers est  vide. 
	FOR i% = 1 TO UBOUND(Cdir$)
		Cdir$(i%) = ""
	NEXT i%
	'Initialisation gnrale.
	FaiLinit 2
	tconf% = 0
	xtdir% = False
	xtfich% = False
	' pour obtenir seulement les rpertoires.
	attr1$ = "/A:D/B"
	' <dir.rep> pour contenir les rpertoires.
	attr2$ = "dir.rep"
	' nom de rpertoire et/ou de fichier par dfaut
	attr3$ = "rubik"
	Collect attr1$, attr2$, attr3$, Cdir$()
	' pour obtenir uniquement les noms de fichiers, extension .rbk par dfaut
	attr1$ = "*.rbk /B"
	'  placer dans fichier <dir.txt>
	attr2$ = "dir.txt"
	' rubik = nom gnrique par dfaut, attr3$ = "rubik"
	Collect attr1$, attr2$, attr3$, Cdir$()
	IF xtfich% THEN	' = True 
		' chercher la borne suprieure du nombre  de fichiers
		FOR i% = 1 TO UBOUND(Cdir$)
			IF Cdir$(i%) <> "" THEN
				Mind% = i%
			ELSEIF Cdir$(i%) = "" THEN
				EXIT FOR
			END IF
		NEXT i%
	Tri Cdir$()
	END IF
	SCREEN 12
	DO
		q$ = " Finale "
		hf% = Mconfig%(q$)
		' attente  HF = 1  Cube normal, ou	HF = 2  Rotation des faces
		' Cas 1, cube normal
		FaiLinit 1
		FaiLinit 2
		efface
		q$ = " Initiale "
		hi% = Mconfig%(q$)
		IF (hf% = 1) AND (hi% = 1) THEN
			Locate 6, 4
			PRINT " *** Vous ne pouvez pas avoir une configuration INITIALE = Cube normal ***"
			Locate 8, 14: PRINT " *** et une configuration FINALE = Cube normal !  ***"
			Locate 9, 14: PRINT " ***** Auquel cas, le logiciel ne set  rien !  ****"
			Locate 12, 14
			PRINT " *********   Recommencez  votre selection S.V.P. ********* "
			Delier# = 5:Delay
			' effacer les messages
			efface
		ELSEIF	(hf% = 2 AND hi% = 2) OR (hf% = 1 AND hi% = 2)_
			OR	(hf% = 1 AND hi% = 3) OR (hf% = 2 AND hi% = 3) THEN
			EXIT DO
		END IF
	LOOP
	' Rotation des faces
	IF (hi% = 2) AND (hf% = 1) THEN
		movself 1
		Affect
		tconf% = 1
	ELSEIF (hi% = 2) AND (hf% = 2) THEN
		movself 0
		locate 27, 2
		PRINT " Voulez-vous un autre exercice?   <O>ui     <N>on";
		DO UNTIL nc$ = "O" OR nc$ = "N"
			nc$ = UCASE$(INKEY$)
		LOOP
		IF nc$ = "O" THEN
			CLEAR
			RUN 5
		END IF
		END
	ELSEIF (hi% = 3) AND (hf% = 2) THEN
		' pour extension future si besoin...
	END IF
	IF hi% = 3 THEN
		AffCadr 10
		' Si fichier(s) existant
		IF xtfich% THEN
			color P%(7): Locate 4, 2
			FOR i% = 1 to 6
				PRINT STRING$(50, " ")
				Locate csrlin, 2
			NEXT i%
			Locate 4, 4: PRINT " Rcuprer les donnes ?  <O / N> ";
			psa$ = Req$(psa$, "O", "N")
		END IF
		Locate 6, 4: PRINT " fonctionnement pas  pas ? <O / N> ";
		pmsa$ = Req$(pmsa$, "O", "N")
		Locate 4, 4: PRINT STRING$(40, " ")
		Locate 6, 4: PRINT STRING$(40, " ")
		IF (psa$ = "O") AND (xtfich%) THEN
			' afficher les fichiers
			IF Mind% <> 0 THEN Affichier Mind%, Cdir$()
			Locate Csrlin + 2, 4: PRINT "Quel Fichier ? de 1  ";Mind%;"  ";
			Loq% = CSRLIN: Posa% =  POS(0)
			Locate 27, 2: PRINT "Attente 2 car.  Si slection de 1  9 appuyer sur <Entre>"
			i% = 0
			DO UNTIL (i% > 0) AND (i% <= Mind%) 
				i% =  VAL(INPUT$(2))
			LOOP
			effa27
			Locate Loq%, Posa%
			Color P%(1): PRINT i%
			Locate 27, 2: PRINT "Une touche pour continuer"
			sleep
			effa27
			Color P%(7)
			nomfic$ = Cdir$(i%)
			Nfich% = FREEFILE
			OPEN nomfic$ FOR BINARY AS Nfich%
			LirEcrir Nfich%, C%(), 1
			CLOSE #Nfich%
			color P%(1)
			Affect
			tconf% = 2
		ELSE
			CLS
			Dkolfac
			tconf% = 1
		END IF
	END IF
	IF tconf% = 1 THEN
		CLS
		AffCadr 10 
		Locate 4, 4: PRINT " Sauvegarder les donnes <O / N> ";
		sa$ = Req$(sa$, "O", "N")
		IF sa$ = "O" THEN
			Nfich% = FREEFILE
			Locate 5, 4
			IF xtfich% = False THEN
				Cfichier Mind%, Mname$
				OPEN Mname$ FOR BINARY AS Nfich%
			ELSEIF Mind% < UBOUND(Cdir$) THEN
				Cfichier Mind%, Mname$
				OPEN Mname$ FOR BINARY AS Nfich%
			ELSEIF Mind% = UBOUND(Cdir$) THEN
				PRINT "Le maximum de fichiers existe dj! "
				Locate CSRLIN, 4
				PRINT "en remplacer un ? <O> ou <N>"
				sa1$ = Req$(sa1$, "O", "N")'				
				Locate 5, 4 :PRINT STRING$(50," ")
				Locate 5, 4 :PRINT STRING$(50," ")
				'CLS
				IF sa1$ = "N" THEN
					PRINT " Fichier non sauvegard ";
					PRINT " Limite atteinte. (limite = ";UBOUND(Cdir$)
				ELSE
					AFFichier Mind%, Cdir$()
					PRINT " Quel fichier ? " ;
					Rng% = VAL(INPUT$(2))
					Mname$ = Cdir$(Rng%)
					OPEN Mname$ FOR BINARY AS Nfich%
				END IF
			END IF
			LirEcrir Nfich%, C%(), 2
			CLOSE #Nfich%
			PRINT "Fichier ";Mname$, " enregistr" 
		ELSE
			ta% = 11
			IF (hi% = 2) AND (hf% = 1) THEN
				locate 3, 1
				PRINT COIbdG$ + STRING$(77, HOriD$) + COIbdD$
			END iF
			FOR ii% = 4 to ta%
				Locate ii%, 1: PRINT STRING$(79, " ")
			NEXT ii%
		END IF
	END IF
	'******** RECONSTITUTION DU CUBE ********
	color P%(1)
	Locate 27, 5: PRINT "< une touche pour continuer >"
	wll$ = UCASE$(INPUT$(1))
	effa27
	CLS
	Affcadr 2
	Color P%(1)
	Locate 4, 19: PRINT STRING$(24, "*")
	Locate Csrlin, 20: PRINT "Reconstitution du cube"
	Locate Csrlin, 19: PRINT STRING$(24, "*")
'	AFFcol
	' identificateur de progression dans la boucle principale.
	B% = 0
	'variable de dplacement de Saut()
	dx% = 1
	DO	' Boucle principale
		IF pmsa$ = "N" THEN
			Color P%(9)
			Locate 27, 2: PRINT "stopper provisoirement, Appuyez sur T "
			PRINT " puis appuyer sur <entrer>  pour reprendre";
			color P%(1)
		END IF
		'calcul de B%, K%, V%
		CalcV B%, K%, V%, so%(dx%), so%(dx% + 1), so%(dx% + 2)
		' affichage  l'cran
		Posit B%, K%, V%
		'progression de 3 positions
		dx% = dx% + 3
		Ta$ = UCASE$(INKEY$)
		IF Ta$ = "Q" THEN
			Lign% = Csrlin :col% = POS(0)
			Locate 27, 5: PRINT "Voulez vous quitter ?  touche <Q> ou <N> pour continuer"
			Delier# = 5:Delay
			effa27
			Locate 27, 5 
			PRINT "Confirmez SVP  <Q>uite ou <N>on "
			Ta$ = Req$(Ta$, "Q", "N")
			effa27
			IF Ta$ = "Q" THEN
				EXIT DO
			ELSE
				effa27
				Locate Lign%, Col%
			END IF
		END IF
		SELECT CASE B%
			' cas 1  4 , et 9  14   appel   Test  et  TestT1
			CASE 1 TO 4, 9 TO 14
				' 2 paramtres sont ncessaires
				Atrib 0, 13, 1, 13, 1, 0, q0%, q1%, 0, 0, 0
				' cas K% = 1
				IF K% = 1 THEN
					Test q0%, q1%, V%, Rf1$, Cm1$
				' cas K% de 2  12
				ELSEIF (K% > 1) AND (K% < 13) THEN
					TestT1 q0%, q1%, V%, Rf1$, Rf2$, Cm1$, Cm2$
				END IF
			'  cas 5  8 , et 16, 17  font appel  TestK1 et TestK2
			CASE 5 TO 8, 16, 17
				' 4 paramtres sont ncessaires
				Atrib 0, 9, 0, 9, 0, 0, q0%, q1%, q2%, q3%, 1
				IF B% < 9 THEN mg% = Id3%(B% - 4) + K% - 1
				IF B% = 16 OR B% = 17 THEN mg% = Id3%(B% - 11) + K% - 1
				Rf3$ = Bf3$(mg%)
				Cm3$ = Bc3$(mg%)
				' cas K% = 1
				IF K% = 1 THEN
					TestK1 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Cm1$, Cm2$
				' cas K% de 2  8
				ELSEIF (K% > 1) AND (K% < 9) THEN
					TestK2 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Rf3$, Cm1$, Cm2$, Cm3$
				END IF
			' cas 15 spcial. fait appel 2 fois  Test si K% = 2
			CASE 15
				' cas K% = 1 et K% = 2
				Atrib 0, 3, 0, 0, 0, 0, q0%, q1%, 0, 0, 0
					Test q0%, q1%, V%, Rf1$, Cm1$
				' cas K% = 2
				IF K% = 2 THEN
					Locate Afli%, Afcol%
					Atrib 0, 3, 0, 0, 0, 1, q0%, q1%, 0, 0, 0
					Test q0%, q1%, V%, Rf1$, Cm1$
				END IF
			CASE 18
				' cas K% = 1
				Atrib 0, 2, 0, 2, 0, 0, q0%, q1%, q2%, q3%, 1
				IF K% = 1 THEN
					TestK1 q0%, q1%, q2%, q3%, V%, Rf1$, Rf2$, Cm1$, Cm2$
				ELSE
					' si B% = 18 et K% = 2, position non rsolue
					PRINT "POSITION IMPOSSIBLE"
				END IF
		END SELECT
		' si B% = 18  c'est fini !
	LOOP UNTIL B% = 18
	IF pmsa$ = "N" THEN
		Locate 5, 50: PRINT STRING$(30, " ")
		Locate 6, 50: PRINT STRING$(30, " ")
		effa27
		PRINT STRING$(50, " ");
	END IF
	Locate 27, 2: PRINT " "; stat%; " mouvements effectus! "; "  < une touche pour finir >"
	SLEEP
	effa27
	PRINT " Voulez-vous un autre exercice?   <O>ui     <N>on";
	DO UNTIL nc$ = "O" OR nc$ = "N"
		nc$ = UCASE$(INKEY$)
	LOOP
	IF nc$ = "O" THEN
		CLEAR
		RUN 5
	END IF
	END
	traiterreur:
	SELECT CASE ERR
		CASE 5
			PRINT "** Appel de fonction interdit - Erreur "; ERR
			RESUME NEXT
		CASE 6
			PRINT "** Dpassement de capacit - Erreur "; ERR
			Berre% = Berre% + 1
			IF Berre% > 10 THEN END
			RESUME NEXT
		CASE 7
			PRINT "** Mmoire Insuffisante - Erreur "; ERR
			PRINT "   arrt du programme "
			PRINT " Corrigez le dfaut si possible ";
			PRINT "   et relancez le programme !  "
			END
		CASE 9
			PRINT "** Indice en dehors des limites - Erreur "; ERR
			Cerre% = Cerre% + 1
			IF Crre% > 10 THEN END
			RESUME NEXT
		CASE 52, 64
			PRINT "** Nom de fichier incorrect - Erreur "; ERR
			Perre% = Perre% + 1
			IF Perre% > 10 THEN END
			RESUME NEXT
		CASE 71
			PRINT "** Disque non prt - Erreur "; ERR
			Derre% = Derre% + 1
			IF Derre% > 10 THEN
				PRINT "Erreur d'accs au disque dur "
				END
			END IF
			RESUME NEXT
		CASE 53, 76:	
			PRINT "** Fichier ou chemin d'accs introuvable - ERREUR "; ERR
			PRINT " Le programme ne trouve pas les fichiers cubdata.rbk "
			PRINT "  et/ou transind.rbk qui sont indispensables. "
			PRINT "  Fin du programme ! rectifiez, et relancez le programme."
			END 
		CASE ELSE
			PRINT "** Erreur "; ERR
			'  assigner un 'label',  si doute d'un risque d'erreur
			'  l'endroit   identifier du programme
			PRINT ERL
		RESUME NEXT
	END SELECT
	'  **** fin de cubrn2M.bas (principal)****
 '********************************************************************
SUB Cfichier (pa%, mn$)
 ' cration de fichier
 '********************************************************************
				pa% = pa% + 1
				PRINT "un fichier Rubik" + LTRIM$(STR$(pa%));".RBK va tre cr "
				Mn$ = "RUBIK" + LTRIM$(STR$(pa%)) + ".RBK"
END SUB
 '********************************************************************
SUB Affichier (pb%, md$())
 ' afficher les fichiers
 '********************************************************************
	Locate 4, 3: PRINT "Fichiers disponnibles :"
	Locate 5, 3
	xu% = 0
	FOR i% = 1 to pb%
		xu% = xu% + 1
		IF LEN(md$(i%)) = 10 THEN
			PRINT i%;" "; md$(i%);" ";
		ELSE
			PRINT i%; md$(i%) ;
		END IF
		IF xu% = 5 THEN
			PRINT: Locate Csrlin, 3
			xu% = 0
		END IF
	NEXT i%	
END SUB
 '********************************************************************
SUB AffCadr (ap%)
 ' Affichage un cadre sur l'ecran
 '********************************************************************
	color P%(7)
	Boiteds 1, 1, 77, ap% 
	Locate 2, (78 - INT(LEN("* * * * R U B I K ' S   C U B E * * * *"))) / 2
	PRINT "* * * * R U B I K ' S   C U B E * * * *"

END SUB
 '********************************************************************
SUB AFFcol
 ' entre: nant
 ' sortie: affichage  l'cran des couleurs des faces
 '********************************************************************
	' --- Aide aux couleurs des faces
	Locate 1, 2
	FOR t% = 1 TO nbfac%
		Color P%(t%)
		IF t% = 1 THEN
			PRINT nocou(CO%(t%)).kol;" : "; CO%(t%);
		ELSEIF t% = 3 OR t% = 5 THEN
			PRINT " ";nocou(CO%(t%)).kol;" : "; CO%(t%);
		ELSE
			Locate csrlin, pos(0) + 1
			PRINT nocou(CO%(t%)).kol;" : "; CO%(t%)
		END IF
	NEXT t%
	color P%(1)
	PRINT
END SUB
 '********************************************************************
SUB Affect
 ' affecte les donnes sur tableau de 20 positions
 '					soit 8 sommets de 3 facettes
 '					et  12 artes de 2 facettes.
 ' en  entre: 		tableaux communs 	s%(),  C%()
 ' sortie: 			tableau  s%() ,
 '				 tableau  C(i%, j%)
 '				affects et contrle de validit des donnes
 '********************************************************************
	FOR i% = 1 TO nbfac%
		FOR j% = 1 TO nfacet%
		' remplace la valeur de C%(i, j) par le poids 2^(x-1)
			C%(i%, j%) = VO%(C%(i%, j%))
		NEXT j%
	NEXT i%
	CLS
	' ---- Reprage des petits cubes ----
	' **Sommets**
	' Par exemple, s%(1) = C%(face1, cube 7) + C%(face2, cube 3) + C%(face3, cube 1)
	s%(1)  = C%(1, 7) + C%(2, 3) + C%(3, 1)	' somme poids 2^x coin haut avant gauche
	s%(2)  = C%(1, 1) + C%(2, 1) + C%(5, 3)	' somme poids 2^x coin haut arrire gauche
	s%(3)  = C%(1, 3) + C%(4, 3) + C%(5, 1)	' somme poids 2^x coin haut arrire droit
	s%(4)  = C%(1, 9) + C%(3, 3) + C%(4, 1)	' somme poids 2^x coin haut avant droit
	s%(5)  = C%(2, 9) + C%(3, 7) + C%(6, 1)	' somme poids 2^x coin bas avant gauche
	s%(6)  = C%(2, 7) + C%(5, 9) + C%(6, 7)	' somme poids 2^x coin bas arrire gauche
	s%(7)  = C%(4, 9) + C%(5, 7) + C%(6, 9)	' somme poids 2^x coin bas arrire droit
	s%(8)  = C%(3, 9) + C%(4, 7) + C%(6, 3)	' somme poids 2^x coin bas avant droit
	' **artes**
	s%(9)  = C%(1, 4) + C%(2, 2)				' somme poids 2^x arte suprieure gauche
	s%(10) = C%(1, 2) + C%(5, 2)				' somme poids 2^x arte suprieure arrire
	s%(11) = C%(1, 6) + C%(4, 2)				' somme poids 2^x arte suprieure droite
	s%(12) = C%(1, 8) + C%(3, 2)				' somme poids 2^x arte suprieure avant
	s%(13) = C%(2, 6) + C%(3, 4)				' somme poids 2^x arte mdium avant gauche
	s%(14) = C%(2, 4) + C%(5, 6)				' somme poids 2^x arte mdium arrire gauche
	s%(15) = C%(4, 6) + C%(5, 4)				' somme poids 2^x arte mdium arrire droite
	s%(16) = C%(3, 6) + C%(4, 4)				' somme poids 2^x arte mdium avant droite
	s%(17) = C%(2, 8) + C%(6, 4)				' somme poids 2^x arte infrieure gauche
	s%(18) = C%(5, 8) + C%(6, 8)				' somme poids 2^x arte infrieure arrire
	s%(19) = C%(4, 8) + C%(6, 6)				' somme poids 2^x arte infrieure droite
	s%(20) = C%(3, 8) + C%(6, 2)				' somme poids 2^x arte infrieure avant
	' contrle
	FOR i% = 1 TO 20
		IF (s%(i%) > 56) AND (i% <= 20) THEN
			PRINT " Donnes Impossibles "
			EXIT FOR
		END IF
		FOR pt% = 1 to 20
			IF SS%(pt%) = s%(i%) THEN
				T%(i%) = pt%  ' position occup par le  cube
				EXIT FOR
			END IF
		NEXT pt%
		Z%(T%(i%)) = i%	' position que doit occuper le  cube
	NEXT i%
	IF i% = 21 THEN
		tem% = 1
		initC 3
		Affcub L%, gm$, tem%
		' si pm% <> 21, les donnes sont fausses !
	ELSEIF i% <> 21 THEN
		PRINT "Les donnes sont fausses! Erreur fatale -- arrt du programme"
		END
	END IF
END SUB
 '***********************************************************************
SUB Affcub (LI%, gm$, clm%) STATIC
 ' AVERTISSEMENT :  ne pas modifier l'ordre des faces sans tre sur de ce que l'on fait !
 ' Cet ordre affecte directement l'affichage et les facettes par rapport aux tableaux!
 ' entre: Li% = N facette	gm$ = commande  excuter 	clm% = tem%
 ' sortie: dessin du cube sur cran; fait appel  SUB TraceFace(...)
 '********************************************************************
	 ' ----- Routine d'affichage graphique
	' face 1, 3, 4, 2, 5, 6
	TraceFace 1, 3, 4, 2, 5 , 6
	' conserver la position ligne et colonne (texte) de l'cran
	Lign% = Csrlin: col% =  POS(0) + 1
	Locate 14, 21: PRINT "Face 1"
	Locate 21, 5: PRINT "Face 3"
	Locate 18, 33: PRINT "Face 4"
	Locate 14, 60: PRINT "Face 2"
	Locate 21, 43: PRINT "Face 5"
	Locate 25, 54: PRINT "Face 6"
	' rcuprer ligne et colonne
	IF col% > 80 then Col% = 3
	Locate Lign%, col%
	IF clm% = 1 THEN
		Helpmov LI%, gm$
		Lign% = Csrlin: col% = POS(0)
		IF pmsa$ = "O" THEN
			Locate 27, 5: PRINT "< une touche pour continuer >"
			wl$ = UCASE$(INPUT$(1))
			effa27
			IF wl$ = "Q" THEN END
		ELSE
			' n'est utile que si pas  pas = non
			wc$ = UCASE$(INKEY$)
			IF wc$ = "T" THEN
				sleep
			END IF
			Delier# = .110 + drl#:Delay
		END IF
		Locate Lign%, col%
	END IF
END SUB
 '***********************************************************************
SUB Atrib (e1%, e2%, e3%, e4%, e5%, e6%, e7%, e8%, e9%, e10%, e11%)
 ' attribuer les affichage et commandes
 ' K%  contrler --> e1%, e2% 	et 	e3%, e4%
 ' e5% =  repre pour " K% - 1'
 ' e6% = repre pour "K% + 1"
 ' SI e11% = 0	  THEN	e7% = q0%, e8% = q1% 
 ' SI e11% = 1	  THEN	e7% = q0%, e8% = q1%, e9% = q2%, e10% = q3% 
 '***********************************************************************
	IF (K% > e1%) AND (K% < e2%) AND (e6% = 0) THEN mn% = Id1%(B%) + K%
	IF (K% > e1%) AND (K% < e2%) AND (e6% = 1) THEN mn% = Id1%(B%) + K% + 1
		Rf1$ = Bf1$(mn%)
		Cm1$ = Bc1$(mn%) 
		IF (K% > e3%) AND (K% < e4%) AND (e5% = 0) THEN mm% = Id2%(B%) + K%
		IF (K% > e3%) AND (K% < e4%) AND (e5% = 1) THEN mm% = Id2%(B%) + K% - 1
		Rf2$ = Bf2$(mm%)
		Cm2$ = Bc2$(mm%)
	' calcul les paramtres  transmettre
	IF e6% = 0 THEN jf% = (Calkoef%(bl%(), B%)) + K%
	IF e6% = 1 THEN jf% = (Calkoef%(bl%(), B%)) + K% + 1
	IF e11% = 0 THEN e7% = Aptst(jf%).tst1: e8% = Aptst(jf%).tst2
	IF e11% = 1 THEN e7% = Aptsk(jf%).tsk1: e8% = Aptsk(jf%).tsk2: e9% = Aptsk(jf%).tsk3: e10% = Aptsk(jf%).tsk4
END SUB
 '***********************************************************************
SUB Boiteds (Ligx%, Coly%, lng%, fin%) STATIC
 ' Trace un cadre double ligne sur l'cran
 '  En entre :			Ligx% = Ligne dbut
 '					Coly% = colonne dbut
 '					lng% = largeur du cadre
 '					fin% =  fin du cadre
 ' Sortie :				Affichage du cadre sur cran
 '**********************************************************************
	Locate Ligx%, Coly%: PRINT COIhdG$ + STRING$(lng%, HOriD$) + COIhdD$
	DO
		Ligx% = Ligx% + 1
		Locate Ligx%, Coly%: PRINT DCOte$ + STRING$(lng%, " ") + DCOte$
	LOOP UNTIL Ligx% = fin%
	PRINT COIbdG$ + STRING$(lng%, HOriD$) + COIbdD$
END SUB
 '********************************************************************
SUB Efface
 ' effacer certaines lignes de l'ecran
 '********************************************************************
	Locate 4, 3: PRINT STRING$(54, " ")
	Locate 6, 3: PRINT STRING$(74, " ")
	Locate 7, 3: PRINT STRING$(74, " ")
	Locate 8, 3: PRINT STRING$(54, " ")
	Locate 9, 3: PRINT STRING$(54, " ")
	Locate 12, 14: PRINT STRING$(56, " ")
END SUB
 '********************************************************************
SUB Effa27
 ' efface la ligne 27
 '********************************************************************
	Locate 27, 2: PRINT STRING$(70, " ")
END SUB
 '*********************************************************************
SUB CalcV (d%, e%, f%, g%, h%, al%)
 ' dtermine la valeur de:  B%,  K% , V%
 '  entre:	B%, K%, V%, saut(dx%), saut(dx% + 1), saut(dx% + 2)
 ' Sortie:	B%, K%, V% actualiss
 '********************************************************************
	f% = CF%(g%, h%)			' V%
	e% = Z%(TF%(al%)) - (al% - 1)	' K%
	d% = d% + 1				' B%
END SUB
 '********************************************************************
FUNCTION Calkoef% (bl%(), B%)
 ' calcul les coefficients {jf%}  appel par Atrib pour les routines 
 '		Test,	TestT1,	TestK1,	TestK2
 ' entre :		bl%(), B%,
 ' Sortie  :  	kf1% ( = jf%) dans la fonction Calkoef%
 '********************************************************************
	kf1% = 0
	' cas B% = 1
	IF B% = 1 THEN kf1% = bl%(B%)
	' cas B% compris entre 2 et 4 OU entre 9 et 15 
	IF (B% > 1 AND B% < 5) OR (B% >= 9 AND B% <= 15) THEN
		FOR nx% = 1 TO B%
			kf1% = kf1% + bl%(nx%)
			' si B% entre 9 et 15 racourcir la boucle
			IF (B% >= 9 AND B% <= 15) AND nx% = 4 THEN nx% = 8
		NEXT nx%
	' cas B% compris entre 5 et 8 OU entre 16 et 18 
	ELSEIF (B% >= 5 AND B% < 9) OR (B% > 15) THEN
		FOR nx% = 5 TO B%
			kf1% = kf1% + bl%(nx%)
			' si B% entre 16 et 18 racourcir la boucle
			IF (B% > 15) AND (nx% = 8) THEN nx% = 15
		NEXT nx%
	END IF
	Calkoef% = kf1%
END FUNCTION
 '********************************************************************
SUB Collect (cha1$, cha2$, cha3$, Mir$())
 ' obtenir le catalogue des rpertoires et fichiers.
 '********************************************************************
	SHELL "dir " + cha1$ + " > " + cha2$	' rpertoires ou fichiers
	Nfich% = FREEFILE
	OPEN cha2$ FOR INPUT AS Nfich%
	IF LOF(Nfich%) > 0 THEN
		jk% = 0
		DO UNTIL EOF(Nfich%)
			LINE INPUT #Nfich%, ir$
			ir$ = LCASE$(ir$)
			jk% = jk% + 1
			cha3$ = LCASE$(cha3$)
			IF INSTR(ir$, cha3$) THEN
				IF INSTR(ir$, ".rbk") THEN
					xtfich% = True
					Mir$(jk%) = ir$
				ELSE
					xtdir% = True
				END IF
			END IF
		LOOP
	END IF
	CLOSE #Nfich%
	KILL cha2$
END SUB
 '********************************************************************
SUB Chks
 ' Cheksum si les entres des facettes sont correctes
 ' On doit trouver 9 blanches, 9 vertes ... et 9 jaunes.
 '********************************************************************
	REDIM ctrl%(0 TO 6) 
	FOR op% = 1 TO nbfac%
		FOR om% = 1 TO nfacet%
			' faire la somme des couleurs de facettes identiques
			ctrl%(C%(op%,om%)) = ctrl%(C%(op%,om%)) + C%(op%, om%)
		NEXT om%
	NEXT op%
	FOR op% = 20 to 27
		Locate op%, 2: PRINT STRING$(70, " ")
	NEXT op%
	dom% = 20
	FOR op% = 1 TO nbfac%
		IF ctrl%(op%) <> CO%(op%) * nfacet% THEN
			Locate dom%, 2 
			PRINT " vous avez entr"; ctrl%(op%)/CO%(op%); " facettes "; nocou(op%).kol
			dom% = dom% + 1
		ELSE
			ctrl%(0) = ctrl%(0) + ctrl%(op%)
		END IF
	NEXT op%
	' Si somme de contrle est correcte, tem% = 1
	IF ctrl%(0) = 189 THEN
		tem% = 1
		ERASE ctrl% ' rcuprer de la mmoire
	ELSE
		Locate 26, 2: PRINT " vous devez recommencer la saisie des couleurs des facettes ";
		tem% = 0
		Locate 27, 2: PRINT " <Une touche pour continuer>" 
		sleep
		CLS
	END IF
END SUB
 '********************************************************************
SUB Delay
 ' delai indpendant de la vitesse du CPU.
 '  bas sur les ticks timer (18.2 fois par seconde) = 55ms
 ' en fonction de Delier# exprim en Seconde.
 ' Si Delier# = 0, pas d'excution de la routine.
 '********************************************************************
	IF Delier# = 0 THEN EXIT SUB
	Debut# = TIMER
	WHILE TIMER - Debut# <= Delier#
	WEND
	Delier# = 0	' remettre delier#  0
END SUB
 '********************************************************************
SUB Dkolfac
 ' en entre: 		Interface homme-machine.
 '				La facette cible est noire.
 ' en sortie: 		Couleurs des 54 facettes en 6 groupes de 9.
 ' 				la facette 5 de chaque face est affecte d'office.
 ' 				Au dpart et par dfaut, les facettes sont grises.
 '********************************************************************
 ' Init donnes couleurs des facettes
	DO
		IF tem% = 0 THEN
			FOR i% = 1 TO nbfac%
				FOR j% = 1 TO nfacet%
					C%(i%, j%) = P%(8)
					' couleur de la facette 5
					IF j% = 5 THEN C%(i%, j%) = i%
				NEXT j%
			NEXT i%
			Affcub j%, gm$, tem%
		END IF
		tem% = 0
		' Entre des donnes pour les 6 faces
		FOR i% = 1 TO nbfac%
			AFFcol
			Locate 5, 2: PRINT "	Face"; i%,
			PRINT
			' et pour les 9 facettes
			FOR j% = 1 TO nfacet%
				DO
					Locate 7, 32: PRINT STRING$(4, " ")
					' si facette 5, ne rien faire
					IF j% = 5 THEN EXIT DO
					Locate 7, 2: PRINT " Couleur de la facette   : "; j%; " "
					C%(i%, j%) = 0
					Affcub j%, gm$, tem%
					DO UNTIL (C%(i%, j%) <= 6) AND (C%(i%, j%) > 0)
						C%(i%, j%) = VAL(INKEY$)
					LOOP
					Affcub j%, gm$, tem%
					EXIT DO
				LOOP
			NEXT j%
			Locate 27, 2: PRINT " Valeurs correctes (O/N) :  ",
			Lm$ = "" 
			Lm$ = Req$(Lm$, "O", "N") 
			' effacer le message
			effa27
			' Si entres incorrectes
			IF Lm$ = "N" THEN
				' remettre les facettes couleur grise
				FOR j% = 1 TO nfacet%
					C%(i%, j%) = P%(8)
					' couleur de la facette 5
					IF j% = 5 THEN C%(i%, j%) = i%
				NEXT j%
				' actualiser l'cran
				Affcub j%, gm$, tem%
				' actualiser  i%
				i% = i% - 1
			END IF
		NEXT i%
		'  contrler si pas d'entres doubles
		' si OK, le temoin tem% = 1
		Chks
		IF tem% = 1 THEN Affect: EXIT DO
	LOOP
END SUB
 '********************************************************************
SUB exmov (exc%, gm$)
 ' routine partage d'excution des rotations
 '********************************************************************
	IF exc% < 3 THEN ko% = 3
	IF exc% > 2 AND exc% < 5 THEN ko% = 5
	IF exc% > 4 AND exc% < 7 THEN ko% = 1
	IF exc% > 6 AND exc% < 9 THEN ko% = 6
	IF exc% > 8 AND exc% < 11 THEN ko% = 2
	IF exc% > 10 AND exc% < 13 THEN ko% = 4
	SELECT CASE exc%
		CASE 1, 3, 5, 7, 9, 11
			Sdlm Ko%, 3, 2, 1, 4, 7, 8, 9, 6
		CASE 2, 4, 6, 8, 10, 12
			Sdlm Ko%, 1, 2, 3, 6, 9, 8, 7, 4
	END SELECT
	Translat exc%, L%, gm$
END SUB
 '********************************************************************
SUB FaiLinit (vc%)
 ' Initialiser les tableaux C%() et TF%()
 ' vc% = valeur d'entre de config en fonction de hi% et/ou hf%
 '********************************************************************
	InitC vc%
	InitTF vc%
END SUB
 '********************************************************************
SUB Helpmov (g%, gm$)
 ' aide aux rotations manuelles et affichage des mouvements
 '
 '********************************************************************
	IF bd% = 0 OR g% > LEN(gm$) THEN EXIT SUB
	IF Col% > 70 THEN	  ' pour ajuster l'affichage
		Lign% = Lign% + 1 :Col% = 2
		Locate Lign%, Col%
	END IF 
	DO
		IF g% > LEN(gm$) THEN PRINT "            "; : EXIT DO
		' tenir compte d'un affichage pour L% >= 10
		IF L% < 10 THEN Col% = Col% + 1:Locate Lign%, Col%
		SELECT CASE bd%
			CASE 1, 3, 5, 7, 9, 11
				m% = &H2B ' signe +
			CASE 2, 4, 6, 8, 10, 12
				m% = &H2D ' signe -
		END SELECT
		IF bd% = 1 OR bd% = 2 THEN mc$ = "AVant  ": EXIT DO
		IF bd% = 3 OR bd% = 4 THEN mc$ = "ARiere ": EXIT DO
		IF bd% = 5 OR bd% = 6 THEN mc$ = "HAut   ": EXIT DO
		IF bd% = 7 OR bd% = 8 THEN mc$ = "BAs    ": EXIT DO
		IF bd% = 9 OR bd% = 10 THEN mc$ = "GAuche ": EXIT DO
		IF bd% = 11 OR bd% = 12 THEN mc$ = "DRoit  ": EXIT DO
	LOOP
	PRINT L%; mc$ + CHR$(m%);
END SUB
 '********************************************************************
SUB InitC (y%)
 ' initialiser tableaux	C%() ou
 ' 				CF%() en fonction de la valeur y%
 '********************************************************************
	FOR i% = 1 TO nbfac%
		FOR j% = 1 TO nfacet%
			IF y% = 1 THEN CF%(i%, j%) = C%(i%, j%)
			IF y% = 2 THEN C%(i%, j%) = i%
			IF y% = 3 THEN C%(i%, j%) = W%(C%(i%, j%))
		NEXT j%
	NEXT i%
END SUB
 '********************************************************************
SUB InitTF (rl%)
 ' initialiser tableaux TF%()  	ou T%() et Z%() 	ou Z%()
 ' selon valeur de rl%
 '********************************************************************
	FOR gk% = 1 TO 20
		IF rl% = 1 THEN TF%(gk%) = T%(gk%)
		IF rl% = 2 THEN T%(gk%) = gk%: Z%(gk%) = gk%
		IF rl% = 3 THEN Z%(T%(gk%)) = gk%
	NEXT gk%
END SUB
 '********************************************************************
FUNCTION invert$ (Miss AS STRING)
 ' Inversion du message
	DIM ml$
	ml$ = LEFT$(Miss, 1) + MID$(Miss, 4, 1) + MID$(Miss, 3, 1) + MID$(Miss, 2, 1)
	ml$ = ml$ + MID$(Miss, 5, 1) + MID$(Miss, 8, 1) + MID$(Miss, 7, 1) + MID$(Miss, 6, 1)
	invert$ = ml$
END FUNCTION
 '********************************************************************
SUB invrc (chifr$())
 ' Inversion de TR$(1  4)
 ' 1 vers 1
	chifr$(1) = LEFT$(TR$(1), 1) + RIGHT$(TR$(1),1) + MID$(TR$(1),3,1) + MID$(TR$(1),2,1)
 ' 2 vers 4 chi$ = savegarde tr$(2)
	chi$ = chifr$(2)
	chifr$(2) = LEFT$(TR$(4), 1) + RIGHT$(TR$(4),1) + MID$(TR$(4),3,1) + MID$(TR$(4),2,1)
 ' 3 vers 3
	chifr$(3) = LEFT$(TR$(3), 1) + RIGHT$(TR$(3),1) + MID$(TR$(3),3,1) + MID$(TR$(3),2,1)
 ' 4 vers 2
	chifr$(4) = LEFT$(chi$, 1) + RIGHT$(chi$,1) + MID$(chi$,3,1) + MID$(chi$,2,1)
END SUB
 '********************************************************************
FUNCTION Mconfig% (cn$)
 ' Choix utilisateur
 '********************************************************************
	SHARED hf%
	AffCadr 10
	Locate 4, 2: PRINT " Configuration ";
	Color P%(10): PRINT cn$;
	color P%(1): PRINT " desire : "
	Locate 6, 3: PRINT "	1. Cube normal"
	Locate 7, 3: PRINT "	2. Cube obtenu par rotation des faces"
	IF hf% = 1 THEN Locate 8,3: PRINT "	3. Couleurs des facettes  votre choix"
	PRINT
	Locate Csrlin, 3: PRINT " Numro de votre choix : ";
	Choi% = 0
	DO UNTIL (Choi% > 0) AND (Choi% <= 3)
		Choi% = VAL(INKEY$)
	LOOP
	Locate csrlin, pos(0): PRINT LTRIM$(STR$(Choi%))
	Mconfig% = Choi%
END FUNCTION
 '********************************************************************
SUB movself (zx%)
 ' Mouvements manuels (simulation)
 '********************************************************************
	CLS
	IF zx% = 1 THEN Lign% = Csrlin: col% = POS(0)
	j% = 0
	DO
		Color P%(3)
		PRINT "   ***	Liste des commandes  ***"
		PRINT " "
		color P%(7)
		PRINT "  A - face avant ", "  P - face postrieure"
		PRINT "  H - face haute", "  B - face basse"
		PRINT "  G - face gauche", "  D - face droite"
		PRINT "  Q - Quitter   (si 'Q' est seul, sinon ignor) "
		PRINT "  Si lettre seule = sens montre , si '-' sens contraire"
		color P%(1)
		initTF 3
		Affcub L%, gm$, tem%
		INPUT " Commande : "; gm$
		gm$ = UCASE$(gm$)
		IF (LEN(gm$) = 1) AND (gm$ = "Q") THEN EXIT DO
		tem% = 1
		FOR L% = 1 TO LEN(gm$)
			r$ = MID$(gm$, L%, 1)
			IF r$ = "-" THEN: j% = j% + 1: L% = L% + 1: r$ = MID$(gm$, L%, 1)
			IF r$ = "A" THEN	j% = j% + 1
			IF r$ = "P" THEN	j% = j% + 3
			IF r$ = "H" THEN	j% = j% + 5
			IF r$ = "B" THEN	j% = j% + 7
			IF r$ = "G" THEN	j% = j% + 9
			IF r$ = "D" THEN	j% = j% + 11
			Bd% = j%
			exmov j%, gm$
			j% = 0
		NEXT L%
		initTF 3
		Affcub L%, gm$, tem%
		Affect
	LOOP
'	Affect
END SUB
 '********************************************************************
SUB Posit (rr%, us%, tu%)	'STATIC
 '  Routine de positionnement  l'cran
 ' des valeurs de B%,	K%,	   V%
 '********************************************************************
	Locate 7, 3: PRINT "B:"; rr%, "K:"; us%, "V:"; tu%, "COMMANDES"
	Color P%(9)
	Locate 8, 2: PRINT STRING$(38, CHR$(223)); STRING$(41, " ")
	color P%(1)
	Locate Afli%, Afcol%
END SUB
 '********************************************************************
FUNCTION Req$ (t$, rp1$, rp2$)
	DO UNTIL t$ = rp1$ OR t$ = rp2$
		t$ = UCASE$(INKEY$)
	LOOP
	Req$ = t$
END FUNCTION
 '********************************************************************
SUB Rotax (gm$)
 ' Excute la commande place dans gm$ : Rotation des faces
 '********************************************************************
	Lign% = 9 :col% = 2
	color P%(1)
	FOR L% = 1 TO LEN(gm$)
		Bd% = ASC(MID$(gm$, L%, 1)) - 64
		exmov bd%, gm$
	NEXT L%
	IF L% > LEN(gm$) THEN
		Delier# = 1.2:Delay
		Locate Afli%, Afcol%: PRINT STRING$(38, " ")
		For Gn% = 1 to 5
			Locate Afli% + Gn%, 1: PRINT STRING$(78, " ")
		NEXT Gn%
		Locate Lign%, col%
	END IF
	stat% = stat% + LEN(gm$)
	initTF 3
END SUB
 '********************************************************************
SUB LirEcrir (xfich%, C%(), nz%)
 ' Lire depuis le disque ou crire vers le disque
 ' selon la valeur de nz%
 ' (nz% 	= 1	lire.)	(nz%	= 2	crire.)
 '********************************************************************
	FOR i% = 1 TO nbfac%
		FOR j% = 1 TO nfacet%
			IF nz% = 1 THEN GET #xfich%, ,C%(i%, j%)
			IF nz% = 2 THEN	PUT #xfich%, ,C%(i%, j%)
		NEXT j%
	NEXT i%
END SUB
 '********************************************************************
SUB Tablo (bor%, pfich%, Br$(), Ca$() )
 ' lire les gnrateurs depuis le disque
 '********************************************************************
	FOR i% = 1 TO bor%
		IF i% <= bor%/2 THEN 
			INPUT #pfich%, Br$(i%)
		ELSE
			INPUT #Pfich%, Ca$(i% - bor%/2)
		END IF
	NEXT i%
END SUB
 '********************************************************************
SUB Tablau (bar%, kfich%, nd%(), na%())
 ' lire les Index depuis le disque
 '********************************************************************
	FOR i% = 1 TO bar%
		IF i% <= bar%/2 THEN
			GET #kfich%, ,nd%(i%)
		ELSE
			GET #kfich%, ,na%(i% - bar%/2)
		END IF
	NEXT i%
END SUB
 '********************************************************************
SUB Tablax (ber%, lfich%, ncu%())
 ' lire les Index depuis le disque
 '********************************************************************
	FOR i% = 1 TO ber%
		GET #lfich%, ,ncu%(i%)
	NEXT i%
END SUB
 '********************************************************************
SUB Tablat (bir%, ifich%, atu() AS bap, avu() AS sap, nt%)
 ' lire les Index de format TYPE depuis le disque
 '********************************************************************
	FOR i% = 1 TO bir%
		IF nt% = 1 THEN
			GET #ifich%, , atu(i%).tst1
			GET #ifich%, , atu(i%).tst2
		ELSE
			GET #ifich%, , avu(i%).tsk1
			GET #ifich%, , avu(i%).tsk2
			GET #ifich%, , avu(i%).tsk3
			GET #ifich%, , avu(i%).tsk4
		END IF
	NEXT i%
END SUB 
 '********************************************************************
SUB Sdlm (kt%, s1%, s2%, s3%, s4%, s5%, s6%, s7%, s8%)
 ' Translation en fonction de la face du cube
 ' Sens montre ou inverse (en fonction des paramtres s1%  s8% transmis)
 ' En entre :
 ' kt% = identit de la face
 ' si s1%...s8% valent 3, 2, 1, 4, 7, 8, 9, 6 alors SENS de la MONTRE
 ' si s1%...s8% valent 1, 2, 3, 6, 9, 8, 7, 4 alors SENS INVERSE de la MONTRE
 ' En sortie:
 ' C%(kt%, sX%) translats en fonction du sens (sX% = de 1  8)
 '********************************************************************
	D1% = C%(kt%, s1%)
	D2% = C%(kt%, s2%)
	C%(kt%, s1%) = C%(kt%, s3%)
	C%(kt%, s2%) = C%(kt%, s4%)
	C%(kt%, s3%) = C%(kt%, s5%)
	C%(kt%, s4%) = C%(kt%, s6%)
	C%(kt%, s5%) = C%(kt%, s7%)
	C%(kt%, s6%) = C%(kt%, s8%)
	C%(kt%, s7%) = D1%
	C%(kt%, s8%) = D2%
END SUB
 '********************************************************************
SUB Test (c1%, c2%, av%, af$, cma$)
 ' affichage du contenu de af$
 ' excution du contenu de coma$
 '********************************************************************
	IF (c1% > 0) AND (C%(c1%, c2%) = av%) THEN EXIT SUB
	color P%(7)
	PRINT af$: Rotax cma$
END SUB
 '********************************************************************
SUB TestT1 (d1%, d2%, vb%, f1a$, f2a$, mca1$, mca2$)
 ' affichage des contenus de f1a$ OU f2a$
 ' excution des contenus de moca1$ OU moca2$
 '********************************************************************
	color P%(7)
	IF C%(d1%, d2%) = vb% THEN
		PRINT f1a$
		Rotax mca1$
	ELSE
		PRINT f2a$
		Rotax mca2$
	END IF
END SUB
 '********************************************************************
SUB TestK1 (a1%, a2%, a3%, a4%, va1%, af1$, af2$, ac1$, ac2$)
 ' affichage des contenus de	af1$ OU af2$
 ' excution des contenus de	acmo1$ OU acmo2$
 '********************************************************************
	IF C%(a1%, a2%) = va1% THEN EXIT SUB
	color P%(7)
	IF C%(a3%, a4%) = va1% THEN
		PRINT af1$
		Rotax ac1$
	ELSE
		PRINT af2$
		Rotax ac2$
	END IF
END SUB
 '********************************************************************
SUB TestK2 (b1%, b2%, b3%, b4%, va%, fa1$, fa2$, fa3$, ca1$, ca2$, ca3$)
 ' affichage des contenus de fa1$ OU fa2$ OU fa3$
 ' excution des contenus de camo1$ OU camo2$ OU camo3$
 '********************************************************************
	color P%(7)
	IF C%(b1%, b2%) = va% THEN
		PRINT fa1$
		Rotax ca1$
	ELSEIF C%(b3%, b4%) = va% THEN
		PRINT fa2$
		Rotax ca2$
	ELSE
		PRINT fa3$
		Rotax ca3$
	END IF
END SUB
 '********************************************************************
SUB TraceFace (v1%, v2%, v3%, v4%, v5%, v6%)
 ' attribution des lments transmits v1%  v6% = face
 ' Les paramtres t1%  t13%  sont diffrents en fonction de la face
 ' t14% et t15% ne sont utiliss que pour la face  5
 '********************************************************************
	Kx1% = 175: Ky1% = 230
	Kx2% = 480: Ky2% = Ky1%
	u0% = 0: u1% = 30: u2% = 15: u3% = Kfsn% 
	dt% = (u1% + spr%): du% = (u3% + spr%)
	dv% = (u2% + spr%)
	FOR v7% = 1 TO 6
		t4% = u0%: t5% = u2%: t6% = -u1%
		t7% = u0%: t8% = u3%: t9% = -u1%
		t10% = u1%: t11% = u0%: t13% = 10
		IF v7% = 1 THEN
			t1% = v1%
			t2% = Kx1%: t3% = Ky1%
			t4% = -u3%: t9% = -u2%
			t12% = -15
		ELSEIF v7% = 2 THEN
			t1% = v2%
			t5% = u1%: t8% = u0%
			t12% = -10
		ELSEIF v7% = 3 THEN
			t1% = v3%
			t2% = t2% + (2 * dt%) + du%
			t3% = t3% - (3 * dt%) - u3% - spr% 
			t5% = u1%: t6% = -u3%
			t7% = u2%: t8% = u0%
			t10% = u3%: t11% = -u2%
			t12% = -3
		ELSEIF v7% = 4THEN
			t1% = v4%
			' position du curseur graphique en X (partie 2)
			' position du curseur graphique en Y (partie 2)
			t2% = Kx2%: t3% = Ky2%
			t5% = u1%: t8% = u0%
			t12% = -10
		ELSEIF v7% = 5 THEN
			t1% = v5%
			t2% = t2% - (2 * dt%) - spr%
			t3% = t3% - 2 * u1%
			t4% = -u3%: t6% = u0%
			t7% = u1%: t9% = -u2%
			t10% = u0%: t11% = -u1%
			t12% = -4 
			t14% = t2%: t15% = t3%
		ELSEIF v7% = 6 THEN
			t1% = v6%
			t2% = t2% + (3 * dt%) + (2 * spr%)
			t3% = t3% - (2 * dv%) - spr%
			t4% = -u3%: t6% = u1%
			t9% = -u2%: t10% = -u1%
			t12% = 15
		END IF
		FOR i% = 0 TO 2
			' I% part de 0 au lieu de 1, pour le calcul
			' utilis dans PAINT ....P%(C%(t1%, (3 * i% + j%)))
			FOR j% = 1 TO 3
				' fixe coordonnes x1, y1  trac relatif x1dx, y1  dy
				LINE (t2%, t3%)-STEP(t4%, t5%), 7
				' trac relatif x1 = x1  dx, y1 = y1   dy
				LINE -STEP(t6%, t7%), 7
				'  trac relatif x1 = x1  dx, y1 = y1  dy
				LINE -STEP(t8%, t9%), 7
				'  trac relatif x1 = x1  dx, y1 = y1  dy
				LINE -STEP(t10%, t11%), 7
			' colorer la facette, le pointeur doit tre  l'intrieur de la bordure ferme !
				PAINT STEP(t12%, t13%), P%(C%(t1%, (3 * i% + j%))), 7
				' mettre  jour le(s) pointeur(s) graphique(s) pour le futur trac interne 
				' la face concerne.
				' EX: Dans la face (t1%) la procdure trace les facettes 1, 2 et 3
				IF t1% > 0 AND t1% < 4 THEN
					t2% = t2% + dt%
				ELSEIF t1% > 3 AND t1% < 6 THEN 
					t2% = t2% + du%
					IF t1% = 4 AND t2% = 242 THEN t2% = t2% -1
					t3% = t3% - dv%
				ELSE
					t2% = t2% - du%
					t3% = t3% + dv%
				END IF
			NEXT j%
			' mettre  jour les pointeurs graphiques en x et y pour le futur trac
			' La procdure prpare le trac des facettes 4, 5 et 6 puis
			' le trac des facettes  7, 8 et 9;  t1% = N face
			IF t1% = 1 THEN
				t2% = t2% - (3 * dt%) - u3% - 1
				t3% = t3% + dv%
			ELSEIF t1% = 2 OR t1% = 3 THEN
				t2% = t2% - (3 * dt%)
				t3% = t3% + dt%
			ELSEIF t1% = 4 THEN
				t2% = t2% - (3 * du%)
				t3% = t3% + (3 * (u1% - spr%))
			ELSEIF t1% = 5 THEN
				t2% = t14%
				t3% = t15% + dt%
				t14% = t2%
				t15% = t3%
			ELSE
				t2% = t2% + du% + spr% 
				t3% = t3% - (3 * du%)
			END IF
		NEXT i%
	NEXT v7%
END SUB
 '********************************************************************
SUB TRI (am$())
 '  mettre les fichiers en ordre.
 '------------------------------------------------------------------------------
    DIM tbx$(16)
	SHARED Mind%
	FOR i% = 1 to Mind%
		IF INSTR(am$(i%), ".") = 7 THEN
			xi% = VAL(MID$(am$(i%), 6, 1))
			tbx$(xi%) = am$(i%)
		ELSE
			xi% = VAL(MID$(am$(i%), 6, 2))
			tbx$(xi%) = am$(i%)
		END IF
	NEXT I%
	FOR I% = 1 TO MIND%
		am$(i%) = tbx$(I%)
	NEXT i%
	ERASE tbx$
END SUB
 '********************************************************************
SUB Translat (mx%, lz%, ll$)	'STATIC
 ' Effectue la translation des cubes lmentaires aprs la rotation des faces
 ' Utilisation des variables bt%, bu%, bv%, bw% de valeur respectives 1, 2, 3 et 4
 '********************************************************************
	DIM R.Ms AS STRING * 8
	SELECT CASE mx%
		CASE 1, 2
'   Rotation Face AV SENS MONTRE
			TR$(1) = "1987"
			TR$(2) = "2369"
			TR$(3) = "6123"
			TR$(4) = "4741"
			R.Ms = "AEHDPLMT"
'   Rotation Face AV SENS INVERSE MONTRE
			IF mx% = 2 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = '"ADHEPTML"
		CASE 3, 4
'   Rotation Face AR SENS MONTRE
			TR$(1) = "1123"
			TR$(2) = "4369"
			TR$(3) = "6987"
			TR$(4) = "2741"
			R.Ms = "BCGFJORN"
'   Rotation Face AR SENS INVERSE MONTRE
			IF mx% = 4 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = "BFGCJNRO"
		CASE 5, 6
'   Rotation Face HAute SENS MONTRE
			TR$(1) = "3123"
			TR$(2) = "4123"
			TR$(3) = "5123"
			TR$(4) = "2123"
			R.Ms = "ADCBILKJ"
'   Rotation Face HAute SENS INVERSE MONTRE
			IF mx% = 6 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = "ABCDIJKL"
		CASE 7, 8
'   Rotation Face BAsse SENS MONTRE
			TR$(1) = "3987"
			TR$(2) = "2987"
			TR$(3) = "5987"
			TR$(4) = "4987"
			R.Ms = "EFGHQRST"
'   Rotation Face BAsse SENS INVERSE MONTRE
			IF mx% = 8 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = "EHGFQTSR"
		CASE 9, 10
'   Rotation Face GAuche SENS MONTRE
			TR$(1) = "1741"
			TR$(2) = "5369"
			TR$(3) = "6741"
			TR$(4) = "3741"
			R.Ms = "ABFEINQM"
'   Rotation Face GAuche SENS INVERSE MONTRE
			IF mx% = 10 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = "AEFBIMQN"
		CASE 11, 12
'   Rotation Face DRoite SENS MONTRE
			TR$(1) = "1369"
			TR$(2) = "3369"
			TR$(3) = "6369"
			TR$(4) = "5741"
			R.Ms = "DHGCKPSO"
'   Rotation Face DRoite SENS INVERSE MONTRE
			IF mx% = 12 THEN invrc TR$(): R.Ms = Invert$(R.Ms) ' = "DCGHKOSP"
	END SELECT
	REDIM ma%(4), kf%(4, 3), E%(8)
	FOR ix% = 1 TO 4
		ma%(ix%)	= VAL(LEFT$(TR$(ix%), 1))
		kf%(ix%, bt%)	= VAL(MID$(TR$(ix%), 2, 1))
		kf%(ix%, bu%)	= VAL(MID$(TR$(ix%), 3, 1))
		kf%(ix%, bv%)	= VAL(RIGHT$(TR$(ix%), 1))
	NEXT ix%
	D1% = C%(ma%(bt%), kf%(bt%, bt%))
	D2% = C%(ma%(bt%), kf%(bt%, bu%))
	D3% = C%(ma%(bt%), kf%(bt%, bv%))
	C%(ma%(bt%), kf%(bt%, bt%))	= C%(ma%(bu%), kf%(bu%, bt%))
	C%(ma%(bt%), kf%(bt%, bu%))	= C%(ma%(bu%), kf%(bu%, bu%))
	C%(ma%(bt%), kf%(bt%, bv%))	= C%(ma%(bu%), kf%(bu%, bv%))
	C%(ma%(bu%), kf%(bu%, bt%))	= C%(ma%(bv%), kf%(bv%, bt%))
	C%(ma%(bu%), kf%(bu%, bu%))	= C%(ma%(bv%), kf%(bv%, bu%))
	C%(ma%(bu%), kf%(bu%, bv%))	= C%(ma%(bv%), kf%(bv%, bv%))
	C%(ma%(bv%), kf%(bv%, bt%))	= C%(ma%(bw%), kf%(bw%, bt%))
	C%(ma%(bv%), kf%(bv%, bu%))	= C%(ma%(bw%), kf%(bw%, bu%))
	C%(ma%(bv%), kf%(bv%, bv%))	= C%(ma%(bw%), kf%(bw%, bv%))
	C%(ma%(bw%), kf%(bw%, bt%))	= D1%
	C%(ma%(bw%), kf%(bw%, bu%))	= D2%
	C%(ma%(bw%), kf%(bw%, bv%))	= D3%
	FOR y% = 1 TO LEN(R.Ms)
		E%(y%) = ASC(MID$(R.Ms, y%, 1)) - 64
	NEXT y%
	FOR y% = 1 TO UBOUND(E%)
		IF y% = 1 THEN IT% = T%(E%(y%))
		IF y% < 4 THEN T%(E%(y%)) = T%(E%(y% + 1))
		IF y% = 4 THEN T%(E%(y%)) = IT%
		IF y% = 5 THEN IT% = T%(E%(y%))
		IF (y% >= 5) AND (y% < 8) THEN T%(E%(y%)) = T%(E%(y% + 1))
		IF y% = 8 THEN T%(E%(y%)) = IT%
	NEXT y%
	Affcub lz%, ll$, tem%
END SUB
'******************************************************************************
' Fin de fichier "cubrn2M.bas"
